=== debian/changelog ===
tree-sitter-powershell (0.25.10-2) unstable; urgency=medium

  * d/control: Bump S-V to 4.7.3; drop priority: optional
  * Fix d/rules permissions
  * Team upload to unstable

 -- Matthias Geiger <werdahias@debian.org>  Thu, 26 Feb 2026 19:10:40 +0100

tree-sitter-powershell (0.25.10-1) experimental; urgency=medium

  * Package tree-sitter-powershell 0.25.10 from git
  * Closes: #1121923.

 -- Antonin Delpeuch <antonin@delpeuch.eu>  Sat, 21 Feb 2026 12:30:19 +0100
