=== debian/control ===
Source: tree-sitter-powershell
Maintainer: Tree-sitter Team <team+tree-sitter@tracker.debian.org>
Uploaders: Antonin Delpeuch <antonin@delpeuch.eu>
Build-Depends:
 cargo:native,
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev,
 librust-tree-sitter-0.25+default-dev (>= 0.25.0-~~),
 nodejs,
 rustc:native,
 tree-sitter-cli (>= 0.25),
Standards-Version: 4.7.3
Section: libs
Homepage: https://github.com/airbus-cert/tree-sitter-powershell
Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter-powershell.git
Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter-powershell

Package: tree-sitter-powershell-src
Architecture: all
Depends:
 ${misc:Depends},
 gcc,
 libc6-dev | libc-dev,
 libtree-sitter-dev (>= 0.25),
 make,
 pkgconf,
Description: powershell parser for Tree-sitter (source files)
 This package contains the generated source files for building the powershell parser
 shared object.

Package: librust-tree-sitter-powershell-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev
Provides:
 librust-tree-sitter-powershell+default-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0.25-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0.25+default-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0.25.10-dev (= ${binary:Version}),
 librust-tree-sitter-powershell-0.25.10+default-dev (= ${binary:Version})
Description: powershell grammar for the tree-sitter parser - Rust source code
 tree-sitter-powershell is a tree-sitter grammar for powershell.
 .
 Tree-sitter is a parser generator and incremental parsing library.
 .
 This package contains the source for the Rust tree-sitter-powershell crate,
 packaged for use with cargo.
