=== debian/watch ===
Version: 5

Source: https://github.com/airbus-cert/tree-sitter-powershell/tags
Matching-Pattern: .*/v?(\d\S*)@ARCHIVE_EXT@
